//====================================================================================
//								RealTime Plugin - Created by escapetomsfate
//====================================================================================
#define ORBITER_MODULE
#define STRICT 1
#include "orbitersdk.h"
#include "convert.h"
#include <time.h>
#include <string>

double TargetMJD;
bool TimeWarp = false;
//====================================================================================
//											Entry points
//====================================================================================
//called when the module is loaded
DLLCLBK void InitModule(HINSTANCE hDLL){}

//called when the module is unloaded
DLLCLBK void ExitModule(HINSTANCE hDLL){}

//called when the state is loaded from a scenario
DLLCLBK void opcLoadState (FILEHANDLE scn)
{
	bool ac;
	//read configuration file
	FILEHANDLE config = oapiOpenFile("realtime.cfg", FILE_IN, CONFIG);
	oapiReadItem_bool(config, "ACCEL", ac);
	oapiCloseFile(config, FILE_IN);

char* cline;
	//go through each line of the scenario
	while(oapiReadScenario_nextline(scn, cline))
	{
		//convert to std::string
		std::string line;
		line.append(cline);
		if(line.substr(0, 5) == "TIME=")
		{
		//find the date as a std::string
		std::string datestr = line.substr(5, line.size() - 5);
		//convert to a double
		double mjd = atof(datestr.c_str());
		//find the difference between last saved scenario time and now, and add that to sim MJD
		double dif = oapiGetSysMJD() - mjd;
		TargetMJD = oapiGetSimMJD() + dif;
		if(ac == true)
		{
		TimeWarp = true;
		} else {
		oapiSetSimMJD(TargetMJD, PROP_ORBITAL);
		}
		}
	}

}

DLLCLBK void opcPreStep(double SimT, double SimDT, double mjd)
{
	if(TimeWarp == true )
	{
		sprintf(oapiDebugString(), "Accelerating, Please Wait...");
		double DeltaT = TargetMJD - mjd;
		// Convert DeltaT to seconds
		DeltaT *= 60*60*24;

		if(DeltaT < 0.1)
		{
			TimeWarp = false;
			oapiSetTimeAcceleration(1.0);
			return;
		}
		oapiSetTimeAcceleration(DeltaT + 1);
	} else sprintf(oapiDebugString(), "");
}


//called when the state is saved to a scenario
DLLCLBK void opcSaveState (FILEHANDLE scn)
{
char line[1024];
sprintf_s(line, 1024, "TIME=%f", oapiGetSysMJD());
oapiWriteLine(scn, line);
}